<?php
/**
 * Created by Stefan Warnat
 * User: Stefan
 * Date: 05.10.2017
 * Time: 13:33
 */

class InventoryItemTracer
{
    public static function run() {
        $adb = \PearDatabase::getInstance();

        if(!\SwVtTools\VtUtils::existTable("vtiger_tools_uniqueinventoryid")) {
            echo "Create table vtiger_tools_uniqueinventoryid  ... ok<br>";
            $adb->query("CREATE TABLE `vtiger_tools_uniqueinventoryid` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `sequence` int(10) UNSIGNED NOT NULL,
  `uuid` varchar(65) NOT NULL,
  PRIMARY KEY (`id`,`sequence`)
) ENGINE=InnoDB;");
        }

        $sql = 'SELECT 
vtiger_inventoryproductrel.id, 
vtiger_inventoryproductrel.sequence_no 
FROM vtiger_inventoryproductrel 
LEFT JOIN vtiger_tools_uniqueinventoryid ON (vtiger_tools_uniqueinventoryid.id = vtiger_inventoryproductrel.id AND vtiger_tools_uniqueinventoryid.sequence = vtiger_inventoryproductrel.sequence_no)
WHERE vtiger_tools_uniqueinventoryid.id IS NULL';
        $result = $adb->query($sql);

        $sql = 'INSERT INTO vtiger_tools_uniqueinventoryid SET id = ?, sequence = ?, uuid = ?';

        while($row = $adb->fetchByAssoc($result)) {
            $uid = sha1($row['id'].'_'.$row['sequence_no'].mt_rand(100000,999999));

            $adb->pquery($sql, array($row['id'], $row['sequence_no'], $uid));
        }

        if(\SwVtTools\Config::get('InventoryTracer', 0) == 1) {
            \SwVtTools\Config::set('InventoryTracer', 0);

            $sql = 'DELETE FROM vtiger_eventhandlers WHERE handler_path = "modules/SwVtTools/EventHandler.php" AND event_name = "vtiger.entity.aftersave"';
            $adb->query($sql);
        } else {
            \SwVtTools\Config::set('InventoryTracer', 1);

            $em = new VTEventsManager($adb);

            $em->registerHandler('vtiger.entity.aftersave', 'modules/SwVtTools/EventHandler.php', 'SwVtToolsEventHandler');
        }

        ini_set('display_errors', 1);
        \SwVtTools\Renderer::frontendRenderer();
    }
}

\SwVtTools\Plugin::register('enable Item Unique ID', array('InventoryItemTracer', 'run'), array(
    'description' => 'Allow third party modules to use \SwVtTools_Module_Model::getInventoryChanges, which will return modifications in sequences',
));